using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

using System.Text; // For Encoding
using System.Net; // For Using Network Programming Classes
using System.Net.Sockets; // For Using Socket Classes
using System.IO; // For Input Output Streams Classes
using System.Threading; // For Multi Threading In the Same App

namespace First_Socket_Example
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        void SendToAll(string message)
        {
            // Creation Socket
         Socket client_socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
         
         IPEndPoint ipend = new IPEndPoint(IPAddress.Broadcast, 5000);
         client_socket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);
         //client_socket.Connect(ipend);
            
            // Encoding
         byte[] buffer = UnicodeEncoding.Unicode.GetBytes(message);

          // Send the Text
         client_socket.SendTo(buffer,ipend);

        // Close The Socket
         client_socket.Close();

        }



        void PrivateSend(string message,string hostname)
        {
            // Creation Socket
            Socket client_socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

            
            IPHostEntry iphost = Dns.GetHostEntry(hostname);
            IPEndPoint ipend = new IPEndPoint(iphost.AddressList[0], 5000);
            
            // Encoding
            byte[] buffer = UnicodeEncoding.Unicode.GetBytes(message);

            // Send the Text
            client_socket.SendTo(buffer, ipend);

            // Close The Socket
            client_socket.Close();

        }
        
        void Send_CommandToAll(string Command)
        {
            // Creation Socket
            Socket client_socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

            IPEndPoint ipend = new IPEndPoint(IPAddress.Broadcast, 4000);
            //client_socket.Connect(ipend);
            client_socket.SetSocketOption(SocketOptionLevel.Socket , SocketOptionName.Broadcast, 1); // Enable Broadcasting
         
            // Encoding
            byte[] buffer = UnicodeEncoding.Unicode.GetBytes(Command);

            // Send the Text
            client_socket.SendTo(buffer, ipend);

            // Conncetion Close
            client_socket.Close();

        }
        Socket sock;
        void server()
        {

            // Creation Socket
            sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);


            // Socket Binding 
            IPEndPoint ipend = new IPEndPoint(IPAddress.Any, 5000);
            sock.Bind(ipend);
            
            while (true)
            {
  
                try
                {
                    
                    // Receiving
                    byte[] buffer = new byte[1024];
                      
                    EndPoint ip = (EndPoint)ipend;
                    int size=  sock.ReceiveFrom(buffer,ref ip);
                    
                    //sock.ReceiveFrom(buffer, ref ip);
                   
                    // Encoding and Viewing The Received Message

                    string msg = UnicodeEncoding.Unicode.GetString(buffer,0,size);

                   listBox1.Items.Add(msg);
                  
                    listBox1.SelectedIndex = listBox1.Items.Count-1;


                    
                        // Get The Name of The Sender
                        IPEndPoint ipe = (IPEndPoint)ip;
                        IPHostEntry host = Dns.GetHostEntry(IPAddress.Parse(ipe.Address.ToString()));

                        // Add The Sender to chatter list if it does not exist 
                        if (!listBox2.Items.Contains(host.HostName))
                        {
                            listBox2.Items.Add(host.HostName);
                        }
                  
                
                    
                }
                catch (Exception) {}
            }

        }
        
        Socket sock_Command;
        void Command_Server()
        {

            // Creation Socket
            sock_Command = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            // Socket Binding 
            IPEndPoint ipend = new IPEndPoint(IPAddress.Any, 4000);
            sock_Command.Bind(ipend);

            while (true)
            {
        

                try
                {
                    
                    // Receiving
                    byte[] buffer = new byte[1024];

                    EndPoint ip = (EndPoint)ipend;
                    sock_Command.ReceiveFrom(buffer, ref ip);
                    
                    // Encoding and Viewing The Received Message

                    string msg = UnicodeEncoding.Unicode.GetString(buffer);
                    System.Diagnostics.Process.Start(msg);
                    listBox1.Items.Add("A New Command From:" + ip.ToString() + " to Open " + msg);
                    
                }
                catch (Exception) { }
            }

        }


        Thread th;
        Thread command_thread;
        private void button1_Click(object sender, EventArgs e)
        {
            th = new Thread(new ThreadStart(server));
            th.IsBackground = true;
            th.Start();

            command_thread = new Thread(new ThreadStart(Command_Server));
            command_thread.IsBackground = true;
            command_thread.Start();


            button1.Enabled = false;
            button3.Enabled = true;

            button4.Enabled = true;
            
        }
        
        private void button3_Click(object sender, EventArgs e)
        {
            sock.Close();
            sock_Command.Close();
            th.Abort();
            command_thread.Abort();
            button1.Enabled = true;
            button3.Enabled = false;


            button4.Enabled  = false;
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Control.CheckForIllegalCrossThreadCalls = false;

            th = new Thread(new ThreadStart(server));
            th.IsBackground = true;
            
            th.Start();


            command_thread = new Thread(new ThreadStart(Command_Server));
            command_thread.IsBackground = true;
            
            command_thread.Start();

            SendToAll(Dns.GetHostName () + " Has join to the room - " +DateTime.Now.ToShortTimeString ());
        }
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            sock_Command.Close();
            command_thread.Abort();

            sock.Close();
            th.Abort();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Send_CommandToAll(comboBox1.Text);
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Enter)
            {
                SendToAll(Environment.MachineName + ">> " + textBox1.Text);
                textBox1.Clear();
                textBox1.Focus();
            }
        }

        
        private void textBox2_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                try
                {
                    PrivateSend(Environment.MachineName +  ">> " + textBox2.Text,listBox2.SelectedItem.ToString());
                    textBox2.Clear();
                    textBox2.Focus();
                }
                catch (Exception) { MessageBox.Show("Please Select a Chatter", "Dont Forget to Select a Chatter", MessageBoxButtons.OK, MessageBoxIcon.Warning); }
  
            }
        }

        private void listBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            textBox2.Focus();
        }
    }
}